libevdev: Initialization and setup

Loading...
Searching...
No Matches
Initialization and setup

Initialization, initial setup and file descriptor handling. More...

## Enumerations
enum | libevdev_grab_mode { LIBEVDEV_GRAB , LIBEVDEV_UNGRAB }

## Functions
struct libevdev * | libevdev_new (void)
| Initialize a new libevdev device.
int | libevdev_new_from_fd (int fd, struct libevdev **dev)
| Initialize a new libevdev device from the given fd.
void | libevdev_free (struct libevdev *dev)
| Clean up and free the libevdev struct.
int | libevdev_grab (struct libevdev *dev, enum libevdev_grab_mode grab)
| Grab or ungrab the device through a kernel EVIOCGRAB.
int | libevdev_set_fd (struct libevdev *dev, int fd)
| Set the fd for this struct and initialize internal data.
int | libevdev_change_fd (struct libevdev *dev, int fd)
| Change the fd for this device, without re-reading the actual device.
int | libevdev_get_fd (const struct libevdev *dev)

## Detailed Description

Initialization, initial setup and file descriptor handling.

These functions are the main entry points for users of libevdev, usually a caller will use this series of calls:

struct libevdev *dev;
int err;
dev = libevdev_new();
if (!dev)
return ENOMEM;
err = libevdev_set_fd(dev, fd);
if (err < 0)
printf("Failed (errno %d): %s\n", -err, strerror(-err));
libevdev_free(dev);
libevdev_set_fd
int libevdev_set_fd(struct libevdev *dev, int fd)
Set the fd for this struct and initialize internal data.
libevdev_new
struct libevdev * libevdev_new(void)
Initialize a new libevdev device.
libevdev_free
void libevdev_free(struct libevdev *dev)
Clean up and free the libevdev struct.

libevdev_set_fd() is the central call and initializes the internal structs for the device at the given fd. libevdev functions will fail if called before libevdev_set_fd() unless documented otherwise.

## Enumeration Type Documentation

## ◆ libevdev_grab_mode

enum libevdev_grab_mode

Enumerator
LIBEVDEV_GRAB | Grab the device if not currently grabbed.
LIBEVDEV_UNGRAB | Ungrab the device if currently grabbed.

## Function Documentation

## ◆ libevdev_change_fd()

int libevdev_change_fd | ( | struct libevdev * | dev,
|  | int | fd )

Change the fd for this device, without re-reading the actual device.

If the fd changes after initializing the device, for example after a VT-switch in the X.org X server, this function updates the internal fd to the newly opened. No check is made that new fd points to the same device. If the device has changed, libevdev's behavior is undefined.

libevdev does not sync itself after changing the fd and keeps the current device state. Use libevdev_next_event with the LIBEVDEV_READ_FLAG_FORCE_SYNC flag to force a re-sync.

The example code below illustrates how to force a re-sync of the library-internal state. Note that this code doesn't handle the events in the caller, it merely forces an update of the internal library state.

struct input_event ev;
libevdev_change_fd(dev, new_fd);
libevdev_next_event(dev, LIBEVDEV_READ_FLAG_FORCE_SYNC, &ev);
while (libevdev_next_event(dev, LIBEVDEV_READ_FLAG_SYNC, &ev) == LIBEVDEV_READ_STATUS_SYNC)
; // noop
libevdev_next_event
int libevdev_next_event(struct libevdev *dev, unsigned int flags, struct input_event *ev)
Get the next event from the device.
LIBEVDEV_READ_STATUS_SYNC
@ LIBEVDEV_READ_STATUS_SYNC
Depending on the libevdev_next_event() read flag:
Definition libevdev.h:1094
LIBEVDEV_READ_FLAG_SYNC
@ LIBEVDEV_READ_FLAG_SYNC
Process data in sync mode.
Definition libevdev.h:765
LIBEVDEV_READ_FLAG_FORCE_SYNC
@ LIBEVDEV_READ_FLAG_FORCE_SYNC
Pretend the next event is a SYN_DROPPED and require the caller to sync.
Definition libevdev.h:767
libevdev_change_fd
int libevdev_change_fd(struct libevdev *dev, int fd)
Change the fd for this device, without re-reading the actual device.

The fd may be open in O_RDONLY or O_RDWR.

After changing the fd, the device is assumed ungrabbed and a caller must call libevdev_grab() again.

It is an error to call this function before calling libevdev_set_fd().

Parameters

  dev | The evdev device, already initialized with libevdev_set_fd()
  fd | The new fd

Returns
  0 on success, or -1 on failure.

See also
  libevdev_set_fd

## ◆ libevdev_free()

void libevdev_free | ( | struct libevdev * | dev | ) |

Clean up and free the libevdev struct.

After completion, the `struct libevdev` is invalid and must not be used.

Note that calling libevdev_free() does not close the file descriptor currently associated with this instance.

Parameters

  dev | The evdev device

Note
  This function may be called before libevdev_set_fd().

## ◆ libevdev_get_fd()

int libevdev_get_fd | ( | const struct libevdev * | dev | ) |

Parameters

  dev | The evdev device

Returns
  The previously set fd, or -1 if none had been set previously.

Note
  This function may be called before libevdev_set_fd().

## ◆ libevdev_grab()

int libevdev_grab | ( | struct libevdev * | dev,
|  | enum libevdev_grab_mode | grab )

Grab or ungrab the device through a kernel EVIOCGRAB.

This prevents other clients (including kernel-internal ones such as rfkill) from receiving events from this device.

This is generally a bad idea. Don't do this.

Grabbing an already grabbed device, or ungrabbing an ungrabbed device is a noop and always succeeds.

A grab is an operation tied to a file descriptor, not a device. If a client changes the file descriptor with libevdev_change_fd(), it must also re-issue a grab with libevdev_grab().

Parameters

  dev | The evdev device, already initialized with libevdev_set_fd()
  grab | If true, grab the device. Otherwise ungrab the device.

Returns
  0 if the device was successfully grabbed or ungrabbed, or a negative errno in case of failure.

## ◆ libevdev_new()

struct libevdev * libevdev_new | ( | void |  | ) |

Initialize a new libevdev device.

This function only allocates the required memory and initializes the struct to sane default values. To actually hook up the device to a kernel device, use libevdev_set_fd().

Memory allocated through libevdev_new() must be released by the caller with libevdev_free().

See also
  libevdev_set_fd
  libevdev_free

## ◆ libevdev_new_from_fd()

int libevdev_new_from_fd | ( | int | fd,
|  | struct libevdev ** | dev )

Initialize a new libevdev device from the given fd.

This is a shortcut for

int err;
struct libevdev *dev = libevdev_new();
err = libevdev_set_fd(dev, fd);

Parameters

  | fd | A file descriptor to the device in O_RDWR or O_RDONLY mode.
  [out] | dev | The newly initialized evdev device.

Returns
  On success, 0 is returned and dev is set to the newly allocated struct. On failure, a negative errno is returned and the value of dev is undefined.

See also
  libevdev_free

## ◆ libevdev_set_fd()

int libevdev_set_fd | ( | struct libevdev * | dev,
|  | int | fd )

Set the fd for this struct and initialize internal data.

The fd must be in O_RDONLY or O_RDWR mode.

This function may only be called once per device. If the device changed and you need to re-read a device, use libevdev_free() and libevdev_new(). If you need to change the fd after closing and re-opening the same device, use libevdev_change_fd().

A caller should ensure that any events currently pending on the fd are drained before the file descriptor is passed to libevdev for initialization. Due to how the kernel's ioctl handling works, the initial device state will reflect the current device state after applying all events currently pending on the fd. Thus, if the fd is not drained, the state visible to the caller will be inconsistent with the events immediately available on the device. This does not affect state-less events like EV_REL.

Unless otherwise specified, libevdev function behavior is undefined until a successful call to libevdev_set_fd().

Parameters

  dev | The evdev device
  fd | The file descriptor for the device

Returns
  0 on success, or a negative errno on failure

See also
  libevdev_change_fd
  libevdev_new
  libevdev_free